package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.shellMode) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public b4a.example.classmydialog _imd = null;
public b4a.example.classmylayout _iml = null;
public anywheresoftware.b4a.objects.ListViewWrapper _lv = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button2 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button3 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button4 = null;
  public Object[] GetGlobals() {
		return new Object[] {"Activity",mostCurrent._activity,"Button1",mostCurrent._button1,"Button2",mostCurrent._button2,"Button3",mostCurrent._button3,"Button4",mostCurrent._button4,"imd",mostCurrent._imd,"iml",mostCurrent._iml,"lv",mostCurrent._lv};
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 32;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(-2147483648);
 BA.debugLineNum = 33;BA.debugLine="Activity.LoadLayout(\"Main\")";
Debug.ShouldStop(1);
mostCurrent._activity.LoadLayout("Main",mostCurrent.activityBA);
 BA.debugLineNum = 34;BA.debugLine="iml.Initialize";
Debug.ShouldStop(2);
mostCurrent._iml._initialize(processBA);
 BA.debugLineNum = 35;BA.debugLine="iml.SettingLayout(Activity)";
Debug.ShouldStop(4);
mostCurrent._iml._settinglayout(mostCurrent._activity);
 BA.debugLineNum = 36;BA.debugLine="imd.Initialize(Colors.ARGB(255,50,100,150),Colors.Black)";
Debug.ShouldStop(8);
mostCurrent._imd._initialize(mostCurrent.activityBA,anywheresoftware.b4a.keywords.Common.Colors.ARGB((int) (255),(int) (50),(int) (100),(int) (150)),anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 37;BA.debugLine="End Sub";
Debug.ShouldStop(16);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 43;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(1024);
 BA.debugLineNum = 45;BA.debugLine="End Sub";
Debug.ShouldStop(4096);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 39;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(64);
 BA.debugLineNum = 41;BA.debugLine="End Sub";
Debug.ShouldStop(256);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _bt_click() throws Exception{
		Debug.PushSubsStack("bt_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 59;BA.debugLine="Sub bt_Click";
Debug.ShouldStop(67108864);
 BA.debugLineNum = 60;BA.debugLine="imd.DialogClose";
Debug.ShouldStop(134217728);
mostCurrent._imd._dialogclose();
 BA.debugLineNum = 61;BA.debugLine="End Sub";
Debug.ShouldStop(268435456);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _button1_click() throws Exception{
		Debug.PushSubsStack("Button1_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.ButtonWrapper _bt = null;
 BA.debugLineNum = 51;BA.debugLine="Sub Button1_Click";
Debug.ShouldStop(262144);
 BA.debugLineNum = 52;BA.debugLine="Dim bt As Button";
Debug.ShouldStop(524288);
_bt = new anywheresoftware.b4a.objects.ButtonWrapper();Debug.locals.put("bt", _bt);
 BA.debugLineNum = 53;BA.debugLine="bt.Initialize(\"bt\")";
Debug.ShouldStop(1048576);
_bt.Initialize(mostCurrent.activityBA,"bt");
 BA.debugLineNum = 54;BA.debugLine="bt.Text = \"Close\"";
Debug.ShouldStop(2097152);
_bt.setText((Object)("Close"));
 BA.debugLineNum = 55;BA.debugLine="bt.Gravity = Gravity.CENTER";
Debug.ShouldStop(4194304);
_bt.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER);
 BA.debugLineNum = 56;BA.debugLine="imd.Dialog01(Activity,\"Dialog 1\",\"finestra dialogo semplice\",bt)";
Debug.ShouldStop(8388608);
mostCurrent._imd._dialog01(mostCurrent._activity,"Dialog 1","finestra dialogo semplice",_bt);
 BA.debugLineNum = 57;BA.debugLine="End Sub";
Debug.ShouldStop(16777216);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _button2_click() throws Exception{
		Debug.PushSubsStack("Button2_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.ButtonWrapper _bt1 = null;
anywheresoftware.b4a.objects.ButtonWrapper _bt2 = null;
 BA.debugLineNum = 63;BA.debugLine="Sub Button2_Click";
Debug.ShouldStop(1073741824);
 BA.debugLineNum = 64;BA.debugLine="Dim bt1 As Button";
Debug.ShouldStop(-2147483648);
_bt1 = new anywheresoftware.b4a.objects.ButtonWrapper();Debug.locals.put("bt1", _bt1);
 BA.debugLineNum = 65;BA.debugLine="bt1.Initialize(\"bt\")";
Debug.ShouldStop(1);
_bt1.Initialize(mostCurrent.activityBA,"bt");
 BA.debugLineNum = 66;BA.debugLine="bt1.Text = \"Close\"";
Debug.ShouldStop(2);
_bt1.setText((Object)("Close"));
 BA.debugLineNum = 67;BA.debugLine="bt1.Gravity = Gravity.CENTER";
Debug.ShouldStop(4);
_bt1.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER);
 BA.debugLineNum = 68;BA.debugLine="Dim bt2 As Button";
Debug.ShouldStop(8);
_bt2 = new anywheresoftware.b4a.objects.ButtonWrapper();Debug.locals.put("bt2", _bt2);
 BA.debugLineNum = 69;BA.debugLine="bt2.Initialize(\"bt\")";
Debug.ShouldStop(16);
_bt2.Initialize(mostCurrent.activityBA,"bt");
 BA.debugLineNum = 70;BA.debugLine="bt2.Text = \"Save\"";
Debug.ShouldStop(32);
_bt2.setText((Object)("Save"));
 BA.debugLineNum = 71;BA.debugLine="bt2.Gravity = Gravity.CENTER";
Debug.ShouldStop(64);
_bt2.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER);
 BA.debugLineNum = 72;BA.debugLine="imd.Dialog02(Activity,\"Dialog 1\",\"finestra dialogo semplice\",bt1,bt2)";
Debug.ShouldStop(128);
mostCurrent._imd._dialog02(mostCurrent._activity,"Dialog 1","finestra dialogo semplice",_bt1,_bt2);
 BA.debugLineNum = 73;BA.debugLine="End Sub";
Debug.ShouldStop(256);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _button3_click() throws Exception{
		Debug.PushSubsStack("Button3_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
anywheresoftware.b4a.objects.LabelWrapper _title = null;
 BA.debugLineNum = 75;BA.debugLine="Sub Button3_Click";
Debug.ShouldStop(1024);
 BA.debugLineNum = 77;BA.debugLine="lv.Initialize(\"lv\")";
Debug.ShouldStop(4096);
mostCurrent._lv.Initialize(mostCurrent.activityBA,"lv");
 BA.debugLineNum = 79;BA.debugLine="For i = 0 To 10";
Debug.ShouldStop(16384);
{
final int step47 = 1;
final int limit47 = (int) (10);
for (_i = (int) (0); (step47 > 0 && _i <= limit47) || (step47 < 0 && _i >= limit47); _i = ((int)(0 + _i + step47))) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 80;BA.debugLine="lv.AddSingleLine(\"Line \" & i)";
Debug.ShouldStop(32768);
mostCurrent._lv.AddSingleLine("Line "+BA.NumberToString(_i));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 83;BA.debugLine="Dim title As Label";
Debug.ShouldStop(262144);
_title = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("title", _title);
 BA.debugLineNum = 84;BA.debugLine="title.Initialize(\"\")";
Debug.ShouldStop(524288);
_title.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 85;BA.debugLine="title.Text = \"New dialog\"";
Debug.ShouldStop(1048576);
_title.setText((Object)("New dialog"));
 BA.debugLineNum = 86;BA.debugLine="title.TextSize = 16";
Debug.ShouldStop(2097152);
_title.setTextSize((float) (16));
 BA.debugLineNum = 87;BA.debugLine="title.TextColor = Colors.White";
Debug.ShouldStop(4194304);
_title.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 BA.debugLineNum = 88;BA.debugLine="title.Typeface = Typeface.DEFAULT_BOLD";
Debug.ShouldStop(8388608);
_title.setTypeface(anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD);
 BA.debugLineNum = 89;BA.debugLine="title.Gravity = Gravity.CENTER";
Debug.ShouldStop(16777216);
_title.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER);
 BA.debugLineNum = 91;BA.debugLine="imd.Dialog03(Activity,lv)";
Debug.ShouldStop(67108864);
mostCurrent._imd._dialog03(mostCurrent._activity,mostCurrent._lv);
 BA.debugLineNum = 93;BA.debugLine="End Sub";
Debug.ShouldStop(268435456);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _button4_click() throws Exception{
		Debug.PushSubsStack("Button4_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
anywheresoftware.b4a.objects.LabelWrapper _title = null;
 BA.debugLineNum = 96;BA.debugLine="Sub Button4_Click";
Debug.ShouldStop(-2147483648);
 BA.debugLineNum = 98;BA.debugLine="lv.Initialize(\"lv\")";
Debug.ShouldStop(2);
mostCurrent._lv.Initialize(mostCurrent.activityBA,"lv");
 BA.debugLineNum = 100;BA.debugLine="For i = 0 To 10";
Debug.ShouldStop(8);
{
final int step61 = 1;
final int limit61 = (int) (10);
for (_i = (int) (0); (step61 > 0 && _i <= limit61) || (step61 < 0 && _i >= limit61); _i = ((int)(0 + _i + step61))) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 101;BA.debugLine="lv.AddSingleLine(\"Line \" & i)";
Debug.ShouldStop(16);
mostCurrent._lv.AddSingleLine("Line "+BA.NumberToString(_i));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 104;BA.debugLine="Dim title As Label";
Debug.ShouldStop(128);
_title = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("title", _title);
 BA.debugLineNum = 105;BA.debugLine="title.Initialize(\"\")";
Debug.ShouldStop(256);
_title.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 106;BA.debugLine="title.Text = \"New dialog\"";
Debug.ShouldStop(512);
_title.setText((Object)("New dialog"));
 BA.debugLineNum = 107;BA.debugLine="title.TextSize = 16";
Debug.ShouldStop(1024);
_title.setTextSize((float) (16));
 BA.debugLineNum = 108;BA.debugLine="title.TextColor = Colors.White";
Debug.ShouldStop(2048);
_title.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 BA.debugLineNum = 109;BA.debugLine="title.Typeface = Typeface.DEFAULT_BOLD";
Debug.ShouldStop(4096);
_title.setTypeface(anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD);
 BA.debugLineNum = 110;BA.debugLine="title.Gravity = Gravity.CENTER";
Debug.ShouldStop(8192);
_title.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER);
 BA.debugLineNum = 112;BA.debugLine="imd.Dialog04(Activity,lv,title)";
Debug.ShouldStop(32768);
mostCurrent._imd._dialog04(mostCurrent._activity,mostCurrent._lv,_title);
 BA.debugLineNum = 114;BA.debugLine="End Sub";
Debug.ShouldStop(131072);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 27124, new int[] {4}, "80744881-e39b-43b4-a5c7-13200338c4db");}

    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 19;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 21;BA.debugLine="Dim imd As ClassMyDialog";
mostCurrent._imd = new b4a.example.classmydialog();
 //BA.debugLineNum = 22;BA.debugLine="Dim iml As ClassMyLayout";
mostCurrent._iml = new b4a.example.classmylayout();
 //BA.debugLineNum = 24;BA.debugLine="Dim lv As ListView";
mostCurrent._lv = new anywheresoftware.b4a.objects.ListViewWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Dim Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Dim Button2 As Button";
mostCurrent._button2 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Dim Button3 As Button";
mostCurrent._button3 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Dim Button4 As Button";
mostCurrent._button4 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 30;BA.debugLine="End Sub";
return "";
}
public static String  _lv_itemclick(int _position,Object _value) throws Exception{
		Debug.PushSubsStack("lv_ItemClick (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Position", _position);
Debug.locals.put("Value", _value);
 BA.debugLineNum = 47;BA.debugLine="Sub lv_ItemClick (Position As Int, Value As Object)";
Debug.ShouldStop(16384);
 BA.debugLineNum = 48;BA.debugLine="imd.DialogClose";
Debug.ShouldStop(32768);
mostCurrent._imd._dialogclose();
 BA.debugLineNum = 49;BA.debugLine="End Sub";
Debug.ShouldStop(65536);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 17;BA.debugLine="End Sub";
return "";
}
}
